
        include \masm32\include\masm32rt.inc
        .586
        include \masm32\macros\timers.asm

LoopCount = 250

;----------------------------------------------------------

        .code

_main   proc

;restrict execution to a single core

        INVOKE  GetCurrentProcess
        INVOKE  SetProcessAffinityMask,eax,1

;count and display combinations

        call    combo
        print   ustr$(eax),'  combinations',13,10

;run timing test 5 times

        mov     ecx,5

time00: push    ecx
        counter_begin LoopCount,REALTIME_PRIORITY_CLASS
        call    combo
        counter_end
        print   ustr$(eax),' clock cycles',13,10
        pop     ecx
        dec     ecx
        jnz     time00

;terminate

        inkey
        exit

_main   endp

;----------------------------------------------------------

combo   proc

        push    ebx
        push    ecx
        push    edx
        push    esi
        xor     ebx,ebx
        mov     eax,ebx

combo1: inc     ebx
        mov     ecx,ebx

combo2: inc     ecx
        mov     edx,ecx

combo3: inc     edx
        mov     esi,edx

combo4: inc     esi
        inc     eax
        cmp     esi,100
        jb      combo4

        cmp     edx,99
        jb      combo3

        cmp     ecx,98
        jb      combo2

        cmp     ebx,97
        jb      combo1

        pop     esi
        pop     edx
        pop     ecx
        pop     ebx
        ret

combo   endp

;----------------------------------------------------------

        end     _main

